<?php
namespace Claromentis\Console\Util;

$GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"] ?: array()) + array("_77713ce23683636d057" . "3408c9a0d0ddb" => base64_decode("RGF0YWJhc2UgcGVybWlzc2lvbnMgYXJlIGFkZXF1YXR" . "l"), "_a70083b91f8d3b023706" . "1e06826958e8" => base64_decode("Q2hlY2tpbmcgZGF0YWJhc2" . "UgYXZhaWxhYmlsaXR5Li4u"), "_9810a28102" . "74128200cb2" . "4f15909a3f2" => base64_decode("Q2hlY2tpbmcgZGF0YWJhc2UgcGVybWlzc2lvbn" . "MuLi4="), "_4c93d4c40f7ab1a488c387f" . "7f91a6496" => base64_decode("Q2hlY2tpbmcgaW5zdGFsbGF0aW" . "9uLi4u"), "_5bcefc1eff68a2aa6ab8f" . "35699a56d08" => base64_decode("RGF0YWJhc2UgaXMgbm9" . "0IGF2YWlsYWJsZTog"), "_7b2ca9a105acfcc" . "088d2c15bfe6458b" . "6" => base64_decode("Q29yZSBpcyBub3QgaW5z" . "dGFsbGVk"), "_9636e445fbeaa4bbfe5694ed532de0b" . "1" => base64_decode("RGF0YWJhc2UgcGVybWlzc2lvbnMgaW5zd" . "WZmaWNpZW50"), "_1094b976516d8df" . "54067d448e66e029" . "7" => base64_decode("RGF0YWJhc2UgaXMgYX" . "ZhaWxhYmxl"), "_3e09962b" . "663b985bf" . "8c260ac2e" . "95edc0" => base64_decode("Y2" . "9y" . "ZQ" . "=="));
use Claromentis\Core\Config\Config;
use Claromentis\Core\DAL\DbFactory;
use Claromentis\Core\Module;
use Claromentis\Setup\Exception\NotInstalledException;
use Claromentis\Setup\Task\DatabaseCheck;
use Psr\Log\LoggerAwareInterface;
use Psr\Log\LoggerAwareTrait;
use Psr\Log\NullLogger;
use RuntimeException;




class InstallationChecker implements LoggerAwareInterface
{
    use LoggerAwareTrait;
    protected Config $config;
    protected DbFactory $factory;
    protected Locator $locator;
    protected Module\Api $modules;
    
    
    
    
    
    
    
    
    
    public function __construct(Config $_fd33b1a14db9a1eccfaaa3cb67b5336e, DbFactory $_c8ef295ed962a46e6246480731bf7b99, Locator $_958a49c0e9814c5c29eb8698e3fb6de2, Module\Api $_59eea0afb98cc6c83c49d730362a45fd)
    {
        $this->config = $_fd33b1a14db9a1eccfaaa3cb67b5336e;
        $this->factory = $_c8ef295ed962a46e6246480731bf7b99;
        $this->locator = $_958a49c0e9814c5c29eb8698e3fb6de2;
        $this->modules = $_59eea0afb98cc6c83c49d730362a45fd;
        $this->setLogger(new NullLogger());
    }
    
    
    
    
    
    
    public function isInstalled()
    {
        try {
            $this->logger->info($GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_4c93d4c40f7ab1a488c387f7f91a" . "6496"]);
            $this->verifyInstalled();
        } catch (\Exception $_c35473364fa7a050299058f332ec29c1) {
            return false;
        }
        return true;
    }
    
    
    
    
    
    
    public function checkDatabaseConnection()
    {
        try {
            $this->logger->info($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_a70083b91f8d3b0237061e0682695" . "8e8"]);
            $this->verifyDatabaseConnection();
            $this->logger->debug($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_1094b97651" . "6d8df54067d" . "448e66e0297"]);
        } catch (\Exception $_c35473364fa7a050299058f332ec29c1) {
            
            
            
            $this->logger->info($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_5bcefc1eff68a2aa" . "6ab8f35699a56d08"] . $_c35473364fa7a050299058f332ec29c1->getMessage());
            return false;
        }
        return true;
    }
    
    
    
    
    
    
    public function checkDatabasePermissions()
    {
        try {
            $this->logger->info($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_9810a2810" . "274128200c" . "b24f15909a" . "3f2"]);
            $this->verifyDatabasePermissions();
            $this->logger->debug($GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_77713ce23683" . "636d0573408c9" . "a0d0ddb"]);
        } catch (\Exception $_c35473364fa7a050299058f332ec29c1) {
            
            
            return false;
        }
        return true;
    }
    
    
    
    
    
    
    
    public function verifyInstalled()
    {
        $this->verifyDatabaseConnection();
        $this->verifyDatabasePermissions();
        if (!$this->modules->isInstalled($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_3e09962" . "b663b985" . "bf8c260a" . "c2e95edc" . "0"])) {
            throw new NotInstalledException($GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_7b2ca9a105acfcc088d2" . "c15bfe6458b6"]);
        }
    }
    
    
    
    
    
    
    
    public function verifyDatabaseConnection()
    {
        
        
        $_4504853ce5094b088c8bdc3d570a0a5d = $this->getDatabase();
        
        
        $this->modules->setDatabase($_4504853ce5094b088c8bdc3d570a0a5d);
    }
    
    
    
    
    
    
    
    public function verifyDatabasePermissions()
    {
        $_4504853ce5094b088c8bdc3d570a0a5d = $this->getDatabase();
        $_58bc0ced402c33be307fe4d3d5433ed1 = new DatabaseCheck($this->config, $_4504853ce5094b088c8bdc3d570a0a5d);
        $_58bc0ced402c33be307fe4d3d5433ed1->setLogger($this->logger);
        if (!$_58bc0ced402c33be307fe4d3d5433ed1->Check()) {
            foreach ($_58bc0ced402c33be307fe4d3d5433ed1->GetErrors() as $_ba3845cb79c005cf3269af8c83ddbe5e) {
                $this->logger->error($_ba3845cb79c005cf3269af8c83ddbe5e);
            }
            throw new RuntimeException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_9636e445fb" . "eaa4bbfe569" . "4ed532de0b1"]);
        }
    }
    
    
    
    
    
    
    
    protected function getDatabase()
    {
        return $this->factory->GetInstanceFromConfig($this->config);
    }
}